public class Settings { 
    int    flags;
    int    cacheSize;
    String locale;

    static final int FAST_SCROLL = 1;
    static final int AUTO_ZOOM   = 2;
    static final int BLINKING    = 4;

    static final int MAX_CACHE_SIZE = 10;

    byte[] pack() { 
        byte[] record = new byte[4];
        record[0] = (byte)flags;
        record[1] = (byte)locale.charAt(0);
        record[2] = (byte)locale.charAt(1);
        record[3] = (byte)cacheSize;
        return record;
    }

    Settings(byte[] record) { 
        flags = (byte)record[0];
        locale = new String(record, 1, 2);
        cacheSize = (byte)record[3];
    }

    Settings() {
        flags = FAST_SCROLL|AUTO_ZOOM|BLINKING;
        cacheSize = 4;
        locale = System.getProperty("microedition.locale").substring(0, 2);
    }
}